searchData={"items":[{"type":"module","title":"DenoEx","doc":"DenoEx is used to run javascript and typescript files in a safe environment by utilizing\n[Deno](https://deno.com/runtime).","ref":"DenoEx.html"},{"type":"module","title":"Basics - DenoEx","doc":"","ref":"DenoEx.html#module-basics"},{"type":"module","title":"Configuration - DenoEx","doc":"Configuration of the deno installation directory can be set in a few ways. We can use an\nenvironment variable, application config, or pass it directly to the run command. The\ndifferent configurations are there to facilitate different working situations. The\npriorities are `function options` > `application configuration` > `environment`.\n\n#","ref":"DenoEx.html#module-configuration"},{"type":"module","title":"Function Option - DenoEx","doc":"iex> DenoEx.run({:file, Path.join(~w[test support hello.ts])}, [], [deno_location: \"/Users/akoutmos/Documents/opensource/deno_ex/_build/dev/lib/deno_ex/priv/bin\"])\n     {:ok, \"Hello, world.\\n\"}\n\n#","ref":"DenoEx.html#module-function-option"},{"type":"module","title":"Application Configuration - DenoEx","doc":"import Config\n\n     config :deno_ex,\n       exectutable_location: Path.join(~w[path containing deno])\n\n#","ref":"DenoEx.html#module-application-configuration"},{"type":"module","title":"ENV Variable - DenoEx","doc":"`DENO_LOCATION=path`","ref":"DenoEx.html#module-env-variable"},{"type":"function","title":"DenoEx.executable_path/0","doc":"Returns the location where the deno script is expected to be located.","ref":"DenoEx.html#executable_path/0"},{"type":"function","title":"DenoEx.import_map_path/1","doc":"Returns the default import map path","ref":"DenoEx.html#import_map_path/1"},{"type":"function","title":"DenoEx.lock_dependencies/3","doc":"Locks the Deno dependencies","ref":"DenoEx.html#lock_dependencies/3"},{"type":"function","title":"DenoEx.lock_file_path/1","doc":"Returns the default lock file path","ref":"DenoEx.html#lock_file_path/1"},{"type":"function","title":"DenoEx.run/4","doc":"Uses `deno run` to run a Deno script.","ref":"DenoEx.html#run/4"},{"type":"function","title":"Options - DenoEx.run/4","doc":"* `:deno_location` (`t:String.t/0`) - Sets the path where the deno executable is located.\n\n  Note: It does not include the deno executable. If the executable is located at\n  `/usr/bin/deno` then the `deno_location` should be `/usr/bin`.\n\n* `:allow_env` - Allows read and write access to environment variables.\n\n  `true`: allows full access to the environment variables\n\n  `[String.t()]`: allows access to only the subset of variables in the list.\n\n* `:allow_sys` - Allows access to APIs that provide system information.\n  i.e. hostname, memory usage\n\n  `true`: allows full access\n\n  `[String.t()]`: allows access to only the subset calls.\n  hostname, osRelease, osUptime, loadavg, networkInterfaces,\n  systemMemoryInfo, uid, and gid\n\n* `:allow_net` - Allows network access.\n\n  `true`: allows full access to the network\n\n  `[String.t()]`: allows access to only the network connections specified\n  ie. 127.0.0.1:4000, 127.0.0.1, :4001\n\n* `:allow_hrtime` (`t:boolean/0`) - Allows high-resolution time measurement. High-resolution time can be used in timing attacks and fingerprinting.\n\n* `:allow_ffi` - Allow loading of dynamic libraries.","ref":"DenoEx.html#run/4-options"},{"type":"function","title":"WARNING: - DenoEx.run/4","doc":"Be aware that dynamic libraries are not run in a sandbox and therefore\n  do not have the same security restrictions as the Deno process.\n  Therefore, use it with caution.\n\n  `true`: allows all dlls to be accessed\n\n  `[Path.t()]`: A list of paths to dlls that will be accessible\n\n* `:allow_run` - Allow running subprocesses.","ref":"DenoEx.html#run/4-warning"},{"type":"function","title":"WARNING - DenoEx.run/4","doc":"Be aware that subprocesses are not run in a sandbox and therefore do not have\n  the same security restrictions as the Deno process. Therefore, use it with caution.\n\n  `true`: allows all subprocesses to be run\n\n  `[Path.t()]`: A list of subprocesses to run\n\n* `:allow_write` - Allow the ability to write files.\n\n  `true`: allows all files to be written\n\n  `[Path.t()]`: A list of files that can be written\n\n* `:allow_read` - Allow the ability to read files.\n\n  `true`: allows all files to be read\n\n  `[Path.t()]`: A list of files that can be read\n\n* `:allow_all` (`t:boolean/0`) - Turns on all options and bypasses all security measures\n\n* `:no_remote` (`t:boolean/0`) - Disallows installing of imports from remote locations\n\n* `:import_map` (`t:String.t/0`) - The location of the import map json file for finding vendored dependencies\n\n* `:lock` (`t:String.t/0`) - The location of the lock file for running scripts\n\n* `:cached_only` (`t:boolean/0`) - Only allows chaced dependencies to be used\n\n\n\n  Please refer to [Deno Permissions](https://deno.com/manual@v1.33.1/basics/permissions) for more details.","ref":"DenoEx.html#run/4-warning"},{"type":"function","title":"Examples - DenoEx.run/4","doc":"iex> DenoEx.run({:file, Path.join(~w[test support hello.ts])})\n     {:ok, \"Hello, world.\\n\"}\n\n     iex> DenoEx.run({:file, Path.join(~w[test support args_echo.ts])}, ~w[foo bar])\n     {:ok, \"foo bar\\n\"}\n\n     iex> DenoEx.run({:stdin, \"console.log(\\\"Hello, world.\\\")\"})\n     {:ok, \"Hello, world.\\n\"}","ref":"DenoEx.html#run/4-examples"},{"type":"function","title":"DenoEx.vendor_dependencies/4","doc":"Vendors Deno dependencies into the given location","ref":"DenoEx.html#vendor_dependencies/4"},{"type":"function","title":"DenoEx.vendor_dir/1","doc":"Returns the vendor location where deno script dependencies will be stored","ref":"DenoEx.html#vendor_dir/1"},{"type":"type","title":"DenoEx.options/0","doc":"The arguments for deno","ref":"DenoEx.html#t:options/0"},{"type":"type","title":"DenoEx.script/0","doc":"The path to the script that should be executed, or a tuple denoting\nwhat should be passed to the Deno executable over STDIN.","ref":"DenoEx.html#t:script/0"},{"type":"type","title":"DenoEx.script_arguments/0","doc":"The list of arguements to be passed to the script","ref":"DenoEx.html#t:script_arguments/0"},{"type":"module","title":"DenoEx.DenoDownloader","doc":"This module is responsible for fetching the deno executable from GitHub.","ref":"DenoEx.DenoDownloader.html"},{"type":"function","title":"DenoEx.DenoDownloader.install/2","doc":"This function downloads the deno executable and also sets the permissions of the\nexecutable.","ref":"DenoEx.DenoDownloader.html#install/2"},{"type":"macro","title":"DenoEx.DenoDownloader.is_non_negative_integer/1","doc":"","ref":"DenoEx.DenoDownloader.html#is_non_negative_integer/1"},{"type":"module","title":"DenoEx.Pipe","doc":"The DenoEx pipe.\n\nThis module defines a struct and the main functions for working with deno pipes\nand their responses.","ref":"DenoEx.Pipe.html"},{"type":"function","title":"DenoEx.Pipe.finished?/1","doc":"returns if the pipe is finished running or not","ref":"DenoEx.Pipe.html#finished?/1"},{"type":"function","title":"DenoEx.Pipe.new/3","doc":"Initializes a deno pipe with everything needed to run a deno script.","ref":"DenoEx.Pipe.html#new/3"},{"type":"function","title":"Options - DenoEx.Pipe.new/3","doc":"* `:deno_location` (`t:String.t/0`) - Sets the path where the deno executable is located.\n\n  Note: It does not include the deno executable. If the executable is located at\n  `/usr/bin/deno` then the `deno_location` should be `/usr/bin`.\n\n* `:allow_env` - Allows read and write access to environment variables.\n\n  `true`: allows full access to the environment variables\n\n  `[String.t()]`: allows access to only the subset of variables in the list.\n\n* `:allow_sys` - Allows access to APIs that provide system information.\n  i.e. hostname, memory usage\n\n  `true`: allows full access\n\n  `[String.t()]`: allows access to only the subset calls.\n  hostname, osRelease, osUptime, loadavg, networkInterfaces,\n  systemMemoryInfo, uid, and gid\n\n* `:allow_net` - Allows network access.\n\n  `true`: allows full access to the network\n\n  `[String.t()]`: allows access to only the network connections specified\n  ie. 127.0.0.1:4000, 127.0.0.1, :4001\n\n* `:allow_hrtime` (`t:boolean/0`) - Allows high-resolution time measurement. High-resolution time can be used in timing attacks and fingerprinting.\n\n* `:allow_ffi` - Allow loading of dynamic libraries.","ref":"DenoEx.Pipe.html#new/3-options"},{"type":"function","title":"WARNING: - DenoEx.Pipe.new/3","doc":"Be aware that dynamic libraries are not run in a sandbox and therefore\n  do not have the same security restrictions as the Deno process.\n  Therefore, use it with caution.\n\n  `true`: allows all dlls to be accessed\n\n  `[Path.t()]`: A list of paths to dlls that will be accessible\n\n* `:allow_run` - Allow running subprocesses.","ref":"DenoEx.Pipe.html#new/3-warning"},{"type":"function","title":"WARNING - DenoEx.Pipe.new/3","doc":"Be aware that subprocesses are not run in a sandbox and therefore do not have\n  the same security restrictions as the Deno process. Therefore, use it with caution.\n\n  `true`: allows all subprocesses to be run\n\n  `[Path.t()]`: A list of subprocesses to run\n\n* `:allow_write` - Allow the ability to write files.\n\n  `true`: allows all files to be written\n\n  `[Path.t()]`: A list of files that can be written\n\n* `:allow_read` - Allow the ability to read files.\n\n  `true`: allows all files to be read\n\n  `[Path.t()]`: A list of files that can be read\n\n* `:allow_all` (`t:boolean/0`) - Turns on all options and bypasses all security measures\n\n* `:no_remote` (`t:boolean/0`) - Disallows installing of imports from remote locations\n\n* `:import_map` (`t:String.t/0`) - The location of the import map json file for finding vendored dependencies\n\n* `:lock` (`t:String.t/0`) - The location of the lock file for running scripts\n\n* `:cached_only` (`t:boolean/0`) - Only allows chaced dependencies to be used\n\n\n\n  Please refer to [Deno Permissions](https://deno.com/manual@v1.33.1/basics/permissions) for more details.","ref":"DenoEx.Pipe.html#new/3-warning"},{"type":"function","title":"Examples - DenoEx.Pipe.new/3","doc":"iex> DenoEx.Pipe.new({:file, Path.join(~w[test support hello.ts])})\n     #DenoEx.Pipe \n\n     iex> DenoEx.Pipe.new({:file, Path.join(~w[test support args_echo.ts])}, ~w[foo bar])\n     #DenoEx.Pipe","ref":"DenoEx.Pipe.html#new/3-examples"},{"type":"function","title":"DenoEx.Pipe.output/1","doc":"get the buffer from the desired datastream","ref":"DenoEx.Pipe.html#output/1"},{"type":"function","title":"DenoEx.Pipe.run/1","doc":"Executes the deno pipe in another process and sets up to monitor the results.\n\nWhile running a `Deno.Pipe` sends messages back to the calling process.","ref":"DenoEx.Pipe.html#run/1"},{"type":"function","title":"Examples - DenoEx.Pipe.run/1","doc":"iex> DenoEx.Pipe.new({:file, Path.join(~w[test support hello.ts])}) |> DenoEx.Pipe.run()\n     #DenoEx.Pipe","ref":"DenoEx.Pipe.html#run/1-examples"},{"type":"function","title":"DenoEx.Pipe.send/2","doc":"Sends data to a running process","ref":"DenoEx.Pipe.html#send/2"},{"type":"function","title":"DenoEx.Pipe.status/1","doc":"returns the exit code of a finished pipe","ref":"DenoEx.Pipe.html#status/1"},{"type":"function","title":"DenoEx.Pipe.yield/2","doc":"Waits for a pipe to finish and collects the results.","ref":"DenoEx.Pipe.html#yield/2"},{"type":"function","title":"Examples - DenoEx.Pipe.yield/2","doc":"iex> {:ok, pipe} = DenoEx.Pipe.new({:file, Path.join(~w[test support hello.ts])}) |> DenoEx.Pipe.run() |> DenoEx.Pipe.yield()\n     iex> pipe\n     #DenoEx.Pipe \n\n     iex> {:timeout, pipe} = DenoEx.Pipe.new({:file, Path.join(~w[test support hello.ts])}) |> DenoEx.Pipe.run() |> DenoEx.Pipe.yield(1)\n     iex> pipe\n     #DenoEx.Pipe","ref":"DenoEx.Pipe.html#yield/2-examples"},{"type":"type","title":"DenoEx.Pipe.options/0","doc":"arguments for deno","ref":"DenoEx.Pipe.html#t:options/0"},{"type":"type","title":"DenoEx.Pipe.status/0","doc":"status of the pipe","ref":"DenoEx.Pipe.html#t:status/0"},{"type":"opaque","title":"DenoEx.Pipe.t/0","doc":"Elixir.DenoEx.Pipe","ref":"DenoEx.Pipe.html#t:t/0"},{"type":"opaque","title":"DenoEx.Pipe.t/1","doc":"","ref":"DenoEx.Pipe.html#t:t/1"},{"type":"task","title":"mix compile.deno","doc":"Installs Deno as part of the build process\n\nSee `DenoEx` for information on configuring the location of\ndeno installation.","ref":"Mix.Tasks.Compile.Deno.html"},{"type":"task","title":"mix deno_ex.deps.get","doc":"A mix task for loading deno dependencies cache\n\nThis delegates to `deno cache`","ref":"Mix.Tasks.DenoEx.Deps.Get.html"},{"type":"task","title":"mix deno_ex.install","doc":"A mix task that installs Deno into your project.\n\n# Usage\n\n  > mix deno.install\n\n# Options\n\n  * `:path` (`t:String.t/0`) - The path to install deno. The default value is `\"/Users/akoutmos/Documents/opensource/deno_ex/_build/dev/lib/deno_ex/priv/bin\"`.\n\n* `:chmod` (`t:String.t/0`) - The permissions that will be set on the deno binary. In octal format. The default value is `\"770\"`.","ref":"Mix.Tasks.DenoEx.Install.html"},{"type":"extras","title":"README","doc":"Easily run TypeScript and Javascript using  Deno  right from Elixir!\n \n\n \n   \n     \n   \n\n   \n     \n   \n\n   \n     \n   \n\n   \n     \n   \n \n\n \n\n# Contents\n\n- [Contents](#contents)\n  - [Introduction](#introduction)\n  - [Installation](#installation)\n    - [Installing the Runtime](#installing-the-runtime)\n    - [Using DenoEx to Install Copies of the Runtime](#using-denoex-to-install-copies-of-the-runtime)\n  - [Supporting DenoEx](#supporting-denoex)\n    - [Gold Sponsors](#gold-sponsors)\n    - [Silver Sponsors](#silver-sponsors)\n    - [Bronze Sponsors](#bronze-sponsors)\n  - [Using DenoEx](#using-denoex)\n    - [Handling Dependencies](#handling-dependencies)","ref":"readme.html"},{"type":"extras","title":"Introduction - README","doc":"DenoEx is designed to make it simple to run scripts using [Deno](https://deno.com/runtime) from your Elixir\napplications. Deno is a modern runtime for JavaScript and TypeScript that uses V8 and built-in Rust. It is secure by\ndefault, so you must opt into each level of access your scripts need when running. This includes reading environment\nvariables. It is for this reason that the Deno runtime was selected as I needed a secure sandbox to run external\nJavascript and Typescript programs.","ref":"readme.html#introduction"},{"type":"extras","title":"Installation - README","doc":"The package can be installed by adding `deno_ex` to your list of dependencies in\n`mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:deno_ex, \"~> 0.5.0\"}\n  ]\nend\n```\n\n#","ref":"readme.html#installation"},{"type":"extras","title":"Installing the Runtime - README","doc":"By default Deno will automatically be installed in the package's `priv` directory\nas part of the compilation process. If you would like the build to place Deno in\na different directory you may configure it. See the \"Configuration\" section of\n`DenoEx`.\n\n#","ref":"readme.html#installing-the-runtime"},{"type":"extras","title":"Using DenoEx to Install Copies of the Runtime - README","doc":"Once you have DenoEx, you will need the Deno runtime. We have created a mix task\nthat you can use to install Deno. By default, Deno will be installed in the\n`priv` directory for the `deno_ex` dependency. `my_project/_build/dev/lib/deno_ex/priv/bin`\n\n`mix deno_ex.install`\n\nThe installation path may be changed using `--path  `. Permissions may also\nbe changed on the `deno` executable using `--chmod  `. The default\npermissions are `0x770`.","ref":"readme.html#using-denoex-to-install-copies-of-the-runtime"},{"type":"extras","title":"Supporting DenoEx - README","doc":"If you rely on this library to run TypeScript and Javascript within your application, it would much appreciated\nif you can give back to the project in order to help ensure its continued development.\n\nCheckout my [GitHub Sponsorship page](https://github.com/sponsors/akoutmos) if you want to help out!\n\n#","ref":"readme.html#supporting-denoex"},{"type":"extras","title":"Gold Sponsors - README","doc":"#","ref":"readme.html#gold-sponsors"},{"type":"extras","title":"Silver Sponsors - README","doc":"#","ref":"readme.html#silver-sponsors"},{"type":"extras","title":"Bronze Sponsors - README","doc":"","ref":"readme.html#bronze-sponsors"},{"type":"extras","title":"Using DenoEx - README","doc":"Create a Typescript file with the following contents.\n\n```typescript\nconsole.log(\"Hello, world.\");\n```\n\nOpen iex using `iex -S mix` and then run the TypeScript file:\n\n```elixir\niex > DenoEx.run({:file, \"path/to/file.ts\"})\n```\n\n#","ref":"readme.html#using-denoex"},{"type":"extras","title":"Handling Dependencies - README","doc":"Scripts download dependencies on their first run. The output from downloading ends up in the scripts output. In\norder to avoid the time to download and vendoring at runtime we encourage users to vendor their dependencies.\nYou will first need to configure vendoring.\n\n```elixir\nconfig :deno_ex,\n  scripts_path: [\n    Path.join(~w[test support **]),\n    Path.join(~w[my_scripts hello.ts])\n  ]\n```\n\n`scripts_path` can be a list of paths to scripts or wildcards.\n\n`mix deno_ex.deps.get` will load all dependencies in the cache and update the lock file.\n\nIn order to ensure that your scripts use the dependencies that are cached and locked your\nscripts need a few more arguments.\n\n`cached_only: true` - tells the script to only used cached dependencies\n`lock: path_to_lockfile` - tells the script where the lock file is located","ref":"readme.html#handling-dependencies"},{"type":"extras","title":"VERSION","doc":"0.5.0","ref":"version.html"},{"type":"extras","title":"OCR With Tesseract","doc":"# OCR With Tesseract\n\n```elixir\nMix.install([\n  {:kino, \"~> 0.9\"},\n  {:deno_ex, \"~> 0.2\"}\n])\n```","ref":"tesseract_ocr.html"},{"type":"extras","title":"Introduction - OCR With Tesseract","doc":"This Livebook shows you how you can use the Deno Terreract wrapper in order to\nperform optical character recognition (OCR for short) on images. Use the Kino\ninput form to process your images and take it for a test drive!","ref":"tesseract_ocr.html#introduction"},{"type":"extras","title":"Code - OCR With Tesseract","doc":"```elixir\nform = Kino.Control.form([file: Kino.Input.file(\"File\")], submit: \"Process image\")\n```\n\n```elixir\ntypescript_code = fn path ->\n  {\n    :stdin,\n    \"\"\"\n    import { recognize } from \"https://deno.land/x/tesseract/mod.ts\";\n\n    const output = await recognize(\"#{path}\");\n    console.log(output);\n    \"\"\"\n  }\nend\n\nframe = Kino.Frame.new()\n\nform\n|> Kino.Control.stream()\n|> Kino.listen(fn event ->\n  path = Kino.Input.file_path(event.data.file.file_ref)\n\n  image = path |> File.read!() |> Kino.Image.new(:png)\n\n  {:ok, content} =\n    path\n    |> typescript_code.()\n    |> DenoEx.run([], allow_run: true)\n\n  ocr_result = String.trim(content) |> Kino.Markdown.new()\n\n  render_result = Kino.Layout.grid([image, ocr_result], columns: 2)\n  Kino.Frame.render(frame, render_result)\nend)\n\nframe\n```","ref":"tesseract_ocr.html#code"},{"type":"extras","title":"Site Scraping With DOMParser","doc":"# Site Scraping With DOMParser\n\n```elixir\nMix.install([\n  {:kino, \"~> 0.9\"},\n  {:jason, \"~> 1.4\"},\n  {:deno_ex, \"~> 0.2\"}\n])\n```","ref":"web_scraper.html"},{"type":"extras","title":"Introduction - Site Scraping With DOMParser","doc":"Using the built in Deno fetch API, and the `DOMParser` library you can fetch HTML\ndocuments and parse them. In this example, we are fetching all of the blog posts\nfrom [my blog's](https://akoutmos.com) home page, marshalling all that data into a\nJSON blob, outputting that JSON blob to STDOUT, and then decoding it using Jason.","ref":"web_scraper.html#introduction"},{"type":"extras","title":"Code - Site Scraping With DOMParser","doc":"```elixir\nform = Kino.Control.form([file: Kino.Input.file(\"File\")], submit: \"Process image\")\n```\n\n```elixir\nscript = \"\"\"\nimport { DOMParser } from 'https://deno.land/x/deno_dom/deno-dom-wasm.ts';\n\nconst url = 'https://akoutmos.com';\n\ntry {\n  const res = await fetch(url);\n  const html = await res.text();\n  const document: any = new DOMParser().parseFromString(html, 'text/html');\n\n  const result = Array.from(document.querySelectorAll('.post-preview a')).map((elem) => {\n    return {\n      title: elem.querySelector('h2').innerText,\n      summary: elem.querySelector('div').innerText,\n      link: elem.getAttribute('href')\n    }\n  })\n\n  console.log(JSON.stringify(result))\n} catch(error) {\n  console.log(error);\n}\n\"\"\"\n\n{:ok, result} = DenoEx.run({:stdin, script}, [], allow_net: true)\n\nresult\n|> Jason.decode!()\n|> IO.inspect()\n\n:ok\n```","ref":"web_scraper.html#code"}],"content_type":"text/markdown"}